diff --git a/test/unit/daemon/dispatcher_test.rb b/test/unit/daemon/dispatcher_test.rb
index d5de2782..bbfd61a2 100644
--- a/test/unit/daemon/dispatcher_test.rb
+++ b/test/unit/daemon/dispatcher_test.rb
@@ -216,12 +216,14 @@ class HiveDaemonDispatcherTest < Minitest::Test
                       with_patrol_scheduler: false, project_enabled: true,
                       dispatch_state: nil, status_result: nil,
                       dispatch_request_state_home: nil, dispatch_result_state_home: nil,
-                      with_digest_scheduler: false, with_answer_digest_scheduler: false)
+                      with_digest_scheduler: false, with_answer_digest_scheduler: false,
+                      auto_retry_enabled: true)
     config = {
       "daemon" => {
         "edit_debounce_sec" => 30,
         "poll_interval_sec" => 30,
-        "shutdown_grace_sec" => 60
+        "shutdown_grace_sec" => 60,
+        "auto_retry" => { "enabled" => auto_retry_enabled }
       }
     }
     controller = Hive::Daemon::ConcurrencyController.new(
@@ -2538,7 +2540,8 @@ end
   Q = Hive::Daemon::DispatchRequestQueue
 
   def write_request_file(dir, slug:, request_id:, created_at: T0, argv: nil, project: "p1",
-                         trigger: "answer_complete")
+                         trigger: "answer_complete", requestor: "bot", recovery_id: nil,
+                         recovery_step: nil)
     argv ||= [ "hive", "run", slug, "--json" ]
     path = File.join(Q.directory(state_home: dir), Q.filename_for(created_at: created_at, request_id: request_id))
     payload = {
@@ -2549,11 +2552,13 @@ end
       "project" => project,
       "slug" => slug,
       "argv" => argv,
-      "requestor" => "bot",
+      "requestor" => requestor,
       "chat_id" => 42,
       "update_id" => 99,
       "trigger" => trigger
     }
+    payload["recovery_id"] = recovery_id if recovery_id
+    payload["recovery_step"] = recovery_step if recovery_step
     File.write(path, JSON.generate(payload))
     path
   end
@@ -3124,6 +3129,113 @@ end
     end
   end
 
+  def test_kill_switch_rejects_pending_auto_retry_request
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home, auto_retry_enabled: false
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "AUTOOFF",
+        requestor: "auto_retry", recovery_id: "ar-off", recovery_step: "rerun"
+      )
+
+      dispatcher.tick(now: T0)
+
+      rejected = logger.events.find { |name, attrs| name == :dispatch_request_rejected && attrs[:request_id] == "AUTOOFF" }
+      refute_nil rejected
+      assert_equal "auto_retry_disabled", rejected[1][:reason]
+      assert_empty sup.spawned
+      assert_empty Q.pending(state_home: state_home)
+    end
+  end
+
+  def test_auto_retry_request_without_durable_authorization_is_rejected
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "AUTOBAD",
+        requestor: "auto_retry", recovery_id: "ar-missing", recovery_step: "rerun"
+      )
+
+      dispatcher.tick(now: T0)
+
+      rejected = logger.events.find { |name, attrs| name == :dispatch_request_rejected && attrs[:request_id] == "AUTOBAD" }
+      refute_nil rejected
+      assert_equal "auto_retry_authorization_failed", rejected[1][:reason]
+      assert_empty sup.spawned
+      assert_empty Q.pending(state_home: state_home)
+    end
+  end
+
+  def test_authorized_auto_retry_rerun_dispatches_and_accounts_once
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      dispatcher, sup, _ctrl, _logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      state = Hive::Daemon::AutoRetry::State.new(path: File.join(state_home, "auto-retry.json"))
+      dispatcher.instance_variable_get(:@auto_retry).instance_variable_set(:@state, state)
+      state.upsert!(
+        project: "p1", task_key: "s1", stage: "4-execute",
+        reason: "implementer_failed", phase: "retry_queued",
+        recovery_id: "ar-good", slug: "s1", pending_fingerprint: "fp-good",
+        retry_request_id: "AUTOGOOD",
+        rerun_argv: [ "hive", "run", "s1", "--json" ]
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "AUTOGOOD",
+        requestor: "auto_retry", recovery_id: "ar-good", recovery_step: "rerun"
+      )
+      stub_find_project!(dispatcher, "p1")
+      begin
+        dispatcher.tick(now: T0)
+
+        assert_equal 1, sup.spawned.size
+        assert_equal "AUTOGOOD", sup.spawned.first[:request_id]
+        record = state.find_by_recovery_id("ar-good")
+        assert_equal 1, record["attempts_dispatched"]
+        assert_equal "retry_dispatched", record["phase"]
+
+        dispatcher.tick(now: T0 + 1)
+        assert_equal 1, sup.spawned.size
+        assert_equal 1, state.find_by_recovery_id("ar-good")["attempts_dispatched"]
+      ensure
+        restore_find_project!
+      end
+    end
+  end
+
+  def test_auto_retry_recovery_id_cannot_authorize_different_argv
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      state = Hive::Daemon::AutoRetry::State.new(path: File.join(state_home, "auto-retry.json"))
+      dispatcher.instance_variable_get(:@auto_retry).instance_variable_set(:@state, state)
+      state.upsert!(
+        project: "p1", task_key: "s1", stage: "4-execute",
+        reason: "implementer_failed", phase: "retry_queued",
+        recovery_id: "ar-forged", slug: "s1", retry_request_id: "AUTOFORGED",
+        rerun_argv: [ "hive", "run", "s1", "--json" ]
+      )
+      write_request_file(
+        state_home, slug: "s1", request_id: "AUTOFORGED",
+        argv: [ "hive", "archive", "s1", "--json" ],
+        requestor: "auto_retry", recovery_id: "ar-forged", recovery_step: "rerun"
+      )
+
+      dispatcher.tick(now: T0)
+
+      rejected = logger.events.find do |name, attrs|
+        name == :dispatch_request_rejected && attrs[:request_id] == "AUTOFORGED"
+      end
+      refute_nil rejected
+      assert_equal "auto_retry_authorization_failed", rejected[1][:reason]
+      assert_empty sup.spawned
+    end
+  end
+
   def test_dispatch_request_blocked_when_in_flight_for_same_slug
     Dir.mktmpdir("hive-dispatch-queue") do |state_home|
       dispatcher, sup, ctrl, logger, _mw = make_dispatcher(
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 28ac2224..47c99c2f 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -208,4 +208,13 @@ class EventsTest < Minitest::Test
       File.define_singleton_method(:open, original_open) if original_open
     end
   end
+
+  def test_reencoded_truncated_details_stay_within_the_advertised_cap
+    details = { "quoted" => ('\\"' * (Hive::Events::MAX_DETAILS_BYTES * 2)) }
+
+    bounded = Hive::Events.bound_details(details)
+
+    assert_equal true, bounded["truncated"]
+    assert_operator JSON.generate(bounded).bytesize, :<=, Hive::Events::MAX_DETAILS_BYTES
+  end
 end
